"use strict";

/**
 * @class
 * @constructor
 * @returns {void}
 * @access public
 * @static
 */
export const Check = (function(){

    /**
     * @constructs Check
     * @returns {void}
     * @access private
     * @static
     */
    const Check = function(){};

    /**
     * @param {?any} item 
     * @returns {boolean}
     * @access public
     * @static
     */
    Check.is_function = item => typeof item == "function";

    /**
     * @param {?any} item 
     * @returns {boolean}
     * @access public
     * @static
     */
    Check.is_number = item => typeof item == "number";

    /**
     * @param {?any} item 
     * @returns {boolean}
     * @access public
     * @static
     */
    Check.is_integer = item => Check.is_number(item) && item == item >> 0;

    /**
     * @param {?any} item 
     * @returns {boolean}
     * @access public
     * @static
     */
    Check.is_index = item => Check.is_integer(item) && item >= 0;

    /**
     * @param {?any} item 
     * @returns {boolean}
     * @access public
     * @static
     */
    Check.is_html_object = item => item && item.constructor == Object;

    /**
     * @param {?any} item 
     * @returns {boolean}
     * @access public
     * @static
     */
    Check.is_string = item => typeof item == "string";

    /**
     * @param {?any} item 
     * @returns {boolean}
     * @access public
     * @static
     */
    Check.is_null_or_undefined = item => item === undefined || item === null;

    /**
     * @param {?any} item 
     * @returns {boolean}
     * @access public
     * @static
     */
    Check.is_array = item => item instanceof Array;

    /**
     * @param {?any} item 
     * @returns {boolean}
     * @access public
     * @static
     */
    Check.is_key = item => item && Check.is_string(item) && /^[a-z0-9_]+$/i.test(item);

    Check.is_dictionary = item => item && item.constructor == Object;

    return Check;
})();