# RoutesMaker

RoutesMaker es un pequeño proyecto para gestionar mapas sobre rutas y emplazamientos sobre un entorno vectorial interactuable al ser desarrollado sobre elementos XML/SVG integrados sobre el HTML. La idea es hacer un proyecto que perdure con escalabilidad y aislado del entorno generalista y comunitario a nivel de datos, siendo su propósito principalmente sobre el entorno cliente pese a haber una comunicación remota con las librerías de consumo para la gestión, visualización, interactuación y generación de mapas.

## Escalabilidad

Para poder llevar a cabo la escalabilidad haremos uso de "Drivers", un elemento que básicamente será un entorno de comunicación intermedio entre el entorno de la aplicación y el entorno de mapas. Dicho Driver ha de tener una serie de propiedades que han de cumplirse siempre:

* **box**: Éste será el elemento HTML donde se integre el mapa gráficamente. Normalmente suele ser una capa DIV.
* **map**: Éste será el objeto de Mapa o de gestión del mismo, como puede ser un objeto L.Map cara LeafLet.
* **build**: Éste será un método que construya el mapa gráficamente y lo instale internamente dentro del Driver.
* **on_click**: Éste será un gestor de eventos que salta cuando se haga Click dentro del mapa. Éste devolverá la longitud y la latitud en dicho orden sobre el o los Callbacks.
* **add_dot**: Éste será un método para añadir un punto al mapa.
* **remove_dot**: Éste será un método para eliminar un punto al mapa.
* **move_dot**: Éste será un método para mover un punto concreto en el mapa.

Como podemos ver, el Driver depende de que los objetos que genere el Objeto Mapa sean llamables, por lo que los puntos de gestión del mismo han de tener un elemento público que represente dicho objeto. Por lo tanto, y para prevalecer en un estándar, a dicho elemento lo llamaremos, dentro del Modelo de los Dots, **marker**. Cuando hacemos una llamada a cualquiera de las instrucciones del Driver y requiere del envío de puntos, éstos ya tiene Embedido el ObjectMap para que puedan interactuar.

Otro elemento que ha de llevar el Modelo de los Dots es el **line**, el cual será nulo en el caso del Dot 0, y el resto une sobre su previo.

Este método permite cambiar el Driver siempre que haga falta de una forma relativamente sencilla. La idea es controlar un mapa lógico con datos manejables por los intereses de la aplicación y éstos ser adaptados mediante métodos sobre un Driver.